from datetime import timedelta

class Config(object):
		DEBUG = False
		TESTING = False
		DATABASE_URI = 'sqlite:///:memory:'

class ProductionConfig(Config):
	 # DATABASE_URI = 'mysql+mysqldb://numerote_vrsi22_videos:IPNK?h8pjm~$@190.92.137.198:3306/numerote_vrsi22_videos?charset=utf8mb4'
	 DATABASE_URI = 'mysql+mysqldb://root:@127.0.0.1:3306/numerote_conf_videos?charset=utf8mb4'
	 BASE_URL     = 'http://127.0.0.1:5000'
	 UPLOAD_FOLDER = '/static/uploads'

	 PERMANENT_SESSION_LIFETIME = timedelta(minutes=180)

class DevelopmentConfig(Config):
		DEBUG = True

class SECRET_KEY(Config):
		SECRET_KEY = '5678906567890543346789976565'
